package PR2.HitoriSpiel.Domain;

import java.util.List;

/**
 * Represents the Hitori game board.
 */

public class HitoriBoard {
    private final HitoriCell[][] board;
    private final List<String> solutionCoordinates;

    public HitoriBoard(int[][] numbers, List<String> solutionCoordinates) {
        this.board = new HitoriCell[numbers.length][numbers[0].length];
        this.solutionCoordinates = solutionCoordinates;
        initializeBoard(numbers);
    }

    private void initializeBoard(int[][] numbers){
        for (int i = 0; i < numbers.length; i++) {
            for (int j = 0; j < numbers[i].length; j++) {
                board[i][j] = new HitoriCell(numbers[i][j]);
            }
        }
    }

    public HitoriCell getCell(int row, int col) {
        return board[row][col];
    }

    public int getSize(){
        return board.length;
    }

    //Board zurücksetzen zu dem Anfangszustand
    public void resetBoard(){
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[i].length; j++) {
                board[i][j].setState(HitoriCell.CellState.GRAY);
            }
        }
    }
}
