package PR2.HitoriSpiel.Domain;

import java.io.*;
import java.util.*;

/**
 * Utility class to load the solution from a CSV file.
 */
public class HitoriSolutionLoader {

    /**
     * Loads solution coordinates from a CSV file.
     * @param filePath The path to the CSV file containing solution coordinates.
     * @return A list of "row,column" formatted solution coordinates.
     * @throws IOException If the file cannot be read.
     */
    public static List<String> loadSolution(String filePath) throws IOException {
        List<String> solutionCoordinates = new ArrayList<>();
        try (BufferedReader reader = new BufferedReader(new FileReader(filePath))) {
            String line;
            while ((line = reader.readLine()) != null) {
                solutionCoordinates.add(line.trim());
            }
        }
        return solutionCoordinates;
    }
}